; ------------------------------------------
; * Extra ships?
; * Fix up crappy sprites (drink, ice cream, and 2 spikes too similar)
; * End of game??
; * Level difficulty (and add/modify movement patterns)
; * Make treats cycle (and not random, just the first random)
; * Lives counter should not reset every new level!
; * Better positioning of keys (avoid borders)
; * CGE text
; * Indicators (lives)
; * Reset switch must bring back to the main screen
; * Save up bytes by turning NOPs into loops
; * Fix fire button to start game (press/release)
; * Finish sound (2nd voice for fuel)
; * Pick up key sound
; * Move "press fire" further down
; * Have the Key appear only on later levels
; * Fuel should not decrease while on base
; * Explosion when fuel runs out
; * Implement the Key
; - Fix rolling screens
; ------------------------------------------

; Power-ups che scrollano ogni tanto al centro dello schermo?
; Player Speed, Life, Stop Scroll, Fuel, ...
; Ma anche malus: Increase Scroll, Decrease Player Speed, Decrease Fuel, ...
; Poi barra del Thrust che e' limitato e decrementa.

; * Far muovere il giocatore ogni 2 frames (solo per le X ovviamente)
; - Se il carburante sta finendo il giocatore si muove + lentamente...
; * Il "nemico" sulla prima fascia sara' del cibo, e sara' solo _uno_ sprite
; * Preso il cibo, sull prima fascia appare uno o piu' nemici veri e scompare la linea sotto
; - Nei livelli + avanti, si potrebbe far abbassare la linea mano a mano che il giocatore va giu' cosi' non puo'
;   piu' tornare su ed e' + difficile!
; - Quando il player deve tornare alla base, la base lampeggia per farglielo capire.
; - Si potrebbe fare un livello dove, dopo sganciato, non si puo' piu' muovere destra/sinistra ma solo su/giu!
; - Fasce di nemici che scompaiono...
; - Nemici che si muovono secondo una sine table avanti e indietro (o anche sono in una direzione, accelerando e decelerando)
; - Nemici che si muovono in maneira casuale o intelligente
; - Nemici che, se colpiti, non ti distruggono ma ti bloccano oppure ti rimandano indietro di una fascia
; - "Zapper" o altro nemico che si aggira al livello della base e ti killa se stai li'
; - Shield col fuoco che pero' diminuisce velocemente il fuel..

; TODO a breve:
; * Collisioni con tutti
; - Lancio del player e stats (fuel, vite, livello)

; HOW TO COMPRESS LEVELS DATA:
; 1) Instead of a 2-bytes pointer to the image, use a number that gets multiplied by 8 to obtain a pointer
;    (using carry to set high byte of pointer)
; 2) Remove useless 0
; 3) Don't use levelpointers struct but only a pointer to level data that gets increased using carry to set high byte
; 4) Same as 3 for EnemyDirections and EnemyMoves
;
; OR
;
; 1) 

;
; How to Draw A Playfield.
; by Nick Bensema  6:35PM  9/10/98
;
; Atari 2600 programming is different from any other kind of programming
; in many ways.  Just one of these ways is the flow of the program.
;
; Since the CPU must hold tha TIA's hand through all graphical operations,
; the flow ought to go like this:
;
; Clear memory and registers
; Set up variables
; Loop:
;    Do the vertical blank
;    Do game calculations
;    Draw screen
;    Do more calculations during overscan
;    Wait for next vertical blank
; End Loop.
;    
; What I will do is create an outline, and explain everything I can.
; This program will display "HELLO" and scroll it down the screen.
;
; In writing this program, I will take the opportunity to show you
; how a few simple modifications can completely change a program's
; appearance or behavior.  I will invite you to comment out a few
; lines of code, and alter others, so that you can observe the results.
; 
; I will be using DASM for now.  Conversion to A65 should be trivial.
;
	processor 6502
	include vcs.h

	org $F000

MAX_STRIPE = 6
MIN_STRIPE = 1	; Usato solo per il movimento del player

TOTAL_STRIPES = 7

INITIAL_STRIPE = 0	; Stripe in cui si trova il player all'inizio

PLAYERDELAY_DEFAULT = 2	; 1 = ogni frame

PLAYER_INITIALLIVES = 6

;ENEMYLINECOLOR_DEFAULT = $42
ENEMYLINECOLOR_DEFAULT = $f4

PLAYERX_DEFAULT = 80

TOTAL_LEVELS = 99

FUELLEVEL_DEFAULT = 36	; Starting fuel level
FUELDELAY_DEFAULT = 40	; Fuel decrease delay (in frames) - The lower, the faster
FUELCOLOR_OK = $d4
FUELCOLOR_WARNING = $1a
FUELCOLOR_DANGER = $42

;RAND_SEED = $c4
;RAND_SEED = $2b
RAND_SEED = $35

ENEMY_SHAPES_NUMBER = 16
TREATS_NUMBER = 8

LEVELS_EASY = 2
LEVELS_MEDIUM = 7
;LEVELS_HARD = 

MISSILE_TOP = 6
MISSILE_HEIGHT = 3

Temp = $80

playerX = $81
plrPos = $82
plrOff = $83
plrStripe = $84
plrAnim = $85
plrAnimOff = $86

enemyShapeLo = $87
enemyShapeHi = $88

spr0x = $89

;random = $8a	; $8a libero
MissileStripe = $8a	; Missile/key Stripe position (0 = no missile/key)

;spr0y = $8a
spr0pos = $8b	; Posizione x, ossia un numero da $0 a $d per l'offset sullo schermo
spr0off = $8c	; Offset x per HMPn, da $80 (-8) a $70 (+7)

PlayerDelay = $8d	; Flip/Flop per muovere il player un frame si ed uno no (1 no, 0 si)

PS_temp = $8e

EnemyLineColor = $8f

PlayerDelayDefault = $90

ScreenY = $91	; Y totali (iniziale: 192)
ScreenStripeY = $92	; Y nella stripe (iniziale: 8)
Stripes = $93	; Numero della stripe corrente (iniziale: MAX_STRIPE)

Joystick0 = $94
OldJoystick0 = $95

enemyDelays = $96	; Array of MAX_STRIPES con i delay di EnemyMoves (uno per Stripe), ci vanno i delay di EnemyMoves
enemyPatterns = $96
enemyPos = $9d	; Array of MAX_STRIPES con i POS dei nemici, precalcolati (uno per Stripe)
enemyOff = $a4	; Array of MAX_STRIPES con gli OFFset dei nemici, precalcolati (uno per Stripe)
enemyX = $ab	; Array of MAX_STRIPES che ovviamente contiene le X dei nemici (una per Stripe)
; Totale: 24 bytes :(

; Libero da $b2
GoingUp = $b2	; 0: UP - 1: DOWN

basePos = $b3	; posizione e offset della base in basso
baseOff = $b4
baseX = $b5

plrLives = $b6
plrCollide = $b7
plrExploding = $b8	; 0 se non sta esplodendo, 1 se sta esplodendo
plrDeathAnim = $b9
plrDeathAnimOff = $ba
plrNextLife = $bb

EnemyLineColorDefault = $bc

ChangingDirection = $bd

SaveFirstEnemyX = $be
NewFirstEnemyX = $bf

LevelPtrLo = $c0
LevelPtrHi = $c1

CurrentLevel = $c2

EnemyMovesPtrLo = $c3
EnemyMovesPtrHi = $c4

EnemyDirectionsPtrLo = $c5
EnemyDirectionsPtrHi = $c6

ChangeLevel = $c7

ScanLine = $c8
ScanPix = $c9
PFColorRAM = $ca
ScanPixVal = $cb

PfFuel = $cc	; Fuel indicator (6 bytes: $cc .. $d1)

; Free starting from $d2
FuelLevel = $d2
FuelDelay = $d3
FuelColor = $d4

SoundChannel0Ptr = $d5	; Pointer to sound data for channel 0 (in lo-hi format), 2 bytes
SoundChannel1Ptr = $d7	; Pointer to sound data for channel 1 (in lo-hi format), 2 bytes
SoundChannel0Cnt = $d9	; Counter for channel 0 pointer (init with -1). Set to -1 to stop playing, set to 1 to start.
SoundChannel1Cnt = $da	; Counter for channel 1 pointer (init with -1). Set to -1 to stop playing, set to 1 to start.
SoundChannel0Delay = $db
SoundChannel1Delay = $dc

GameScreen = $dd	; 0/1 = intro  2/3 = level  4/5 = game
;GameScreen = $f8	; 0/1 = intro  2/3 = level  4/5 = game

; Intro 6-digit sprite vars
LoopCount = $81	; Reuse
ptr0 = $82	; Reuse!
ptr1 = $84
ptr2 = $86
ptr3 = $88
ptr4 = $8a
ptr5 = $8c

LevelCounter = $de	; 2 bytes
; Free from $e0

LevelData = $e0	; 14
enemyPatternsPtr = $ee	; 7
; Free from $f5
PatternPointerLo = $f5
PatternPointerHi = $f6
random = $f7

MissileXPos = $f8
ColToAdd = $f9

ReleaseFire = $cc	; Reuse of pfFuel

Start
;
; The 2600 powers up in a completely random state, except for the PC which
; is set to the location at $FFC.  Therefore the first thing we must do is
; to set everything up inside the 6502.
;
	SEI  ; Disable interrupts, if there are any.
	CLD  ; Clear BCD math bit.
;
; You may feel the need to use the stack, in which case:
;
	LDX  #$FF
	TXS  ; Set stack to beginning.
;
; Now the memory and TIA registers must be cleared.  You may feel the
; need to write a subroutine that only clears out a certain section of
; memory, but for now a simple loop will suffice.
;
; Since X is already loaded to 0xFF, our task becomes simply to ocunt
; everything off.
;
	LDA #0
B1      STA 0,X
	DEX
	BNE B1
;
; The above routine does not clear location 0, which is VSYNC.  We will
; take care of that later.
;
; At this point in the code we would set up things like the data
; direction registers for the joysticks and such.  
;

;	LDA #RAND_SEED
;	STA random
;	bit $00		; Do we need some alignment here?!
;	NOP		; or just some time out...?

;	NOP
;	NOP
;	NOP
;	NOP
	NOP
	NOP

;	LDA #0
	STA GameScreen	; Start with the intro screen
		STA random

	LDA <#SoundIntro
	STA SoundChannel0Ptr
	LDA >#SoundIntro
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0

ApplicationLoop		; That's the main loop where coice is made of which screen to display
	LDA GameScreen
	BEQ StartIntroScreen
	CMP #5
	;BEQ MainLoop
	BCS MainLoop
	CMP #1
	BEQ MainLoopIntroScreen
	CMP #2
	BEQ StartLevelScreen
	CMP #3
	BEQ MainLoopLevelScreen
	CMP #4
	BEQ StartGameScreen

StartIntroScreen
	; Temporary sound stuff

	JSR InitIntroScreen
	INC GameScreen	; 1
MainLoopIntroScreen
		INC random
	JSR VerticalBlank
	JSR ProcessSounds
	JSR DrawIntroScreen
	JSR OverScan
	LDA INPT4		; Check fire button
	BMI MainLoopIntroScreen	; Fire button not pressed
;	JMP MainLoopIntroScreen
	INC GameScreen	; 2

	;JMP StartGameScreen
	;JMP StartIntroScreen

	JSR  GameInit

;ReleaseFireButton
;	LDA INPT4		; Check fire button
;	BPL ReleaseFireButton	; Fire button not pressed

	LDA #1
	STA ReleaseFire

	LDA <#SoundStartLevel	; Only play this tune when the game starts
	STA SoundChannel0Ptr
	LDA >#SoundStartLevel
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0

StartLevelScreen
	JSR InitLevelScreen
;	LDA #1
;	STA LevelCounter+1
;	LDA #0
;	STA LevelCounter
	INC GameScreen	; 3
	JMP SetLevelPointers
;	JSR SetLevelPointers
MainLoopLevelScreen
	JSR VerticalBlank
	JSR ProcessSounds
	JSR DrawLevelScreen
;	JSR IntroSprites
;	JMP IntroSprites
	JSR OverScan
	LDA plrLives
	BNE NoLastLevelScreen
	DEC GameScreen
	BNE MainLoopLevelScreen
	JMP ApplicationLoop
NoLastLevelScreen
	LDA INPT4		; Check fire button
	BPL NoReleaseFireButton	; Fire button not pressed
	LDA #0
	STA ReleaseFire
NoReleaseFireButton
	LDA ReleaseFire
	BNE MainLoopLevelScreen
	LDA INPT4		; Check fire button
	BMI MainLoopLevelScreen	; Fire button not pressed
	INC GameScreen	; 4

StartGameScreen
;	JSR  GameInit
	JSR NewLevel

;	LDY #%00100000
;	STY NUSIZ0

;
; Here is a representation of our program flow.
;

	; Temporary sound stuff
	LDA <#SoundStartGame
	STA SoundChannel0Ptr
	LDA >#SoundStartGame
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0

	INC GameScreen	; 5
;	LDA #5
;	STA GameScreen
MainLoop
	;LDA #0
	;STA GameScreen
	JSR  VerticalBlank ;Execute the vertical blank.
	JSR  CheckSwitches ;Check console switches.
	; Process sounds
	;JSR ProcessSounds
;	LDX #6
	JSR ProcessSounds
	JSR  GameCalc      ;Do calculations during Vblank
	JSR  DrawScreen    ;Draw the screen
	JSR  OverScan      ;Do more calculations during overscan
;	JMP  MainLoop      ;Continue forever.
	LDA GameScreen
	CMP #6
	BCC NoIncGameScreen
	INC GameScreen
	LDA GameScreen
;	CMP #200
	CMP #100
	BNE NoIncGameScreen
;	LDA #0
;	LDA #2
;	STA GameScreen
	JMP StartLevelScreen
NoIncGameScreen
	JMP  ApplicationLoop      ;Continue forever.


;
; It is important to maintain a stable screen, and this routine
; does some important and mysterious things.  Actually, the only
; mysterious part is VSYNC.  All VBLANK does is blank the TIA's
; output so that no graphics are drawn; otherwise the screen
; scans normally.  It is VSYNC which tells the TV to pack its
; bags and move to the other corner of the screen.
;
; Fortunately, my program sets VBLANK at the beginning of the
; overscan period, which usually precedes this subroutine, so
; it is not changed here.
;
VerticalBlank  ;*********************** VERTICAL BLANK HANDLER
	LDX  #0
	LDA  #2
;	STA  WSYNC  
;	STA  WSYNC	; Extra?
	STA  WSYNC
	STA  VSYNC ;Begin vertical sync.
	STA  WSYNC ; First line of VSYNC
	STA  WSYNC ; Second line of VSYNC.
;
; But before we finish off the third line of VSYNC, why don't we
; use this time to set the timer?  This will save us a few cycles
; which would be more useful in the overscan area.
;
; To insure that we begin to draw the screen at the proper time,
; we must set the timer to go off just slightly before the end of
; the vertical blank space, so that we can WSYNC up to the ACTUAL
; end of the vertical blank space.  Of course, the scanline we're
; going to omit is the same scanline we were about to waste VSYNCing,
; so it all evens out.
;
; Atari says we have to have 37 scanlines of VBLANK time.  Since
; each scanline uses 76 cycles, that makes 37*76=2888 cycles.
; We must also subtract the five cycles it will take to set the
; timer, and the three cycles it will take to STA WSYNC to the next
; line.  Plus the checking loop is only accurate to six cycles, making
; a total of fourteen cycles we have to waste.  2888-14=2876.
;
; We almost always use TIM64T for this, since the math just won't
; work out with the other intervals.  2880/64=44.something.  It
; doesn't matter what that something is, we have to round DOWN.
;
	LDA  #44
	STA  TIM64T
;
; And now's as good a time as any to clear the collision latches.
;
	LDA #0
	STA CXCLR
;
; Now we can end the VSYNC period.
;
	STA  WSYNC ; Third line of VSYNC.
	STA  VSYNC ; (0)
;
; At this point in time the screen is scanning normally, but
; the TIA's output is suppressed.  It will begin again once
; 0 is written back into VBLANK.
;
	RTS  
;
; Checking the game switches is relatively simple.  
;
; It just so happens that I'm not going to check any game switches
; here.  I'm just going to set up the colors, without even checking
; the B&W switch!  HA!
;
CheckSwitches ;*************************** CONSOLE SWITCH HANDLER
	LDA #0
	STA COLUBK  ; Background will be black.
	LDA SWCHA       ;Read joystick 0
	STA Joystick0   ;Store for later use

	LDA SWCHB
	AND #%00000001
	BNE NoResetGame
	;JSR GameInit	; Se RESET e' premuto, reinizializza il gioco
	;JSR NewLevel
	LDA #0
	STA GameScreen
	JSR StopSounds
NoResetGame

; Nuovo livello?
	LDA ChangeLevel
	BEQ NoChangeLevel
; Increase level counters
	INC CurrentLevel	; Ocio, questo prima sballava...
	LDA LevelCounter+1
	CLC
	ADC #1
	STA LevelCounter+1
	CMP #10
	BNE NoResetLevelCounter
	LDA #0
	STA LevelCounter+1
	INC LevelCounter

NoResetLevelCounter
	JSR NewLevel
	LDA <#SoundFinishLevel
	STA SoundChannel0Ptr
	LDA >#SoundFinishLevel
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0
	LDA #2
	STA GameScreen
NoChangeLevel
	RTS

; --------- ACTIVATE SOUND CHANNEL 0 -----------
ActivateChannel0
	; (Starting here, it's generic code for sound 0)
	LDY #0
	LDA (SoundChannel0Ptr),Y
	STA SoundChannel0Cnt	; Load index to the sound data...
	LDA #1
	STA SoundChannel0Delay	; ...and start sound
	INY
	LDA (SoundChannel0Ptr),Y
	STA AUDC0
	RTS

; --------- ACTIVATE SOUND CHANNEL 1 -----------
ActivateChannel1
	; (Starting here, it's generic code for sound 0)
	LDY #0
	LDA (SoundChannel1Ptr),Y
	STA SoundChannel1Cnt	; Load index to the sound data...
	LDA #1
	STA SoundChannel1Delay	; ...and start sound
	INY
	LDA (SoundChannel1Ptr),Y
	STA AUDC1
	RTS

; --------- Process sound channels ----------
ProcessSounds
	; Plays channel 0, next note
	LDA SoundChannel0Delay
	BMI NoPlaySound0		; No sound to play if delay is < 0
	DEC SoundChannel0Delay
	BNE NoPlaySound0
	; Next note..
	LDY SoundChannel0Cnt
	LDA (SoundChannel0Ptr),Y
	STA AUDF0
	DEY
	LDA (SoundChannel0Ptr),Y
	STA SoundChannel0Delay
	DEY
	LDA (SoundChannel0Ptr),Y
	STA AUDV0
	DEY
	BMI FinishChannel0Sound
	STY SoundChannel0Cnt
	JMP NoPlaySound0

FinishChannel0Sound
	LDA #-1
	STA SoundChannel0Cnt	; Stop channel 0
	LDA #0
	STA AUDV0
NoPlaySound0

	; Plays channel 1, next note
	LDA SoundChannel1Delay
	BMI NoPlaySound1		; No sound to play if delay is < 0
	DEC SoundChannel1Delay
	BNE NoPlaySound1
	; Next note..
	LDY SoundChannel1Cnt
	LDA (SoundChannel1Ptr),Y
	STA AUDF1
	DEY
	LDA (SoundChannel1Ptr),Y
	STA SoundChannel1Delay
	DEY
	LDA (SoundChannel1Ptr),Y
	STA AUDV1
	DEY
	BMI FinishChannel1Sound
	STY SoundChannel1Cnt
	JMP NoPlaySound1

FinishChannel1Sound
	LDA #-1
	STA SoundChannel1Cnt	; Stop channel 0
	LDA #0
	STA AUDV1
NoPlaySound1

	RTS

; Mettere in X la posizione X dello sprite in pixel
CalcSprXPos
	;lda spr0x	; absolute X pixel
	TXA	; absolute X pixel
	lsr
	lsr
	lsr
	lsr
	tay	; /16
	
	sta PS_temp
	
	;lda spr0x
	TXA
	and #15
	clc
	adc PS_temp
	cmp #15
	
	tya
	adc #0
	tay
	sty PS_temp
	iny
	iny
	iny
	
	;lda spr0x
	TXA
	and #15
	clc
	adc PS_temp	; calculate the remainder for the /15
	; Use remainder for fine adjustment
	eor #15
	sbc #7	; -8 to +7
	asl
	asl
	asl
	asl
	
;	sta HMP0                      ; fine movement
;	sta HMP1                      ; fine movement
;	sty spr0pos
;	iny
;	sty spr1pos

;	RETURN:
;	A: Fine Movement (offset)
;	Y: Position
	RTS

;
; Minimal game calculations, just to get the ball rolling.
;
GameCalc ;******************************* GAME CALCULATION ROUTINES
;;	INC PlayfieldY   ;Inch up the playfield
;	INC spr0x
;	LDA spr0x
;	CMP #160
;	BCC NoZeroSpr0x
;	LDA #0
;	STA spr0x
;NoZeroSpr0x

; Resetta il colore per la fascia sulla prima linea
	;LDA #ENEMYLINECOLOR_DEFAULT
	LDA EnemyLineColorDefault
	STA EnemyLineColor
	STA ColToAdd

	LDA GameScreen
	CMP #6
	BCC NoEndOfGame
	JMP MovePlayerX

NoEndOfGame
; Animazione (flicker) al momento che prende la frutta.
	LDA ChangingDirection
	BEQ NotChangingDirection
	; Swappa velocemente le tables
	DEC ChangingDirection
	BNE StillChangingDirection
	LDA #0
	STA plrExploding
	LDA #8
	STA GoingUp	; Alla fine mette il nuovo set di nemici (Fase finale del ChangeDirection)
	LDY #MAX_STRIPE
	LDA NewFirstEnemyX
	STA enemyX,Y
	JMP NotChangingDirection
StillChangingDirection
	LDA #0
	STA plrExploding
	LDA GoingUp
	BEQ ChangeDirectionAnim2
	LDA #0
	STA GoingUp	; Rimette il vecchio set di nemici (Anim)
	LDY #MAX_STRIPE
	LDA SaveFirstEnemyX
	STA enemyX,Y
	JMP MovePlayerX
ChangeDirectionAnim2
	LDA #8
	STA GoingUp	; Mette il nuovo set di nemici (Anim)
	LDY #MAX_STRIPE
	LDA NewFirstEnemyX
	STA enemyX,Y
	JMP MovePlayerX
NotChangingDirection
; Se sta animando l'esplosione del giocatore, non leggere il joy e non muovere niente sullo schermo

; -- Controllo se il player e' sulla prima fascia. Se c'e' e la frutta e' presente, agisce di conseguenza.
	LDA plrExploding
	BEQ NoExploding		; Se non sta esplodendo, allora prosegue normalmente leggendo il joystick
	LDA plrStripe
	CMP #MAX_STRIPE+1
	BEQ PlayerFirstStripeCollide	; Se collide ed e' sulla prima fascia in alto..
	JMP MovePlayerX		; E' importante che la X del player sia sempre calcolata anche mentre esplode!
PlayerFirstStripeCollide	; Collisione con la prima riga..
	LDA GoingUp
	BEQ NoExplodingFirstLine	; Se stavamo andando su e collide con la prima fascia, allora non esplode
	JMP MovePlayerX
NoExplodingFirstLine
	; Presa la frutta:
	LDA #8
	STA GoingUp		; Da ora in poi il player deve andare giu'! (ci mette 8 cosi' poi lo usa come incremento all'array dei nemici)
	LDA #0
	STA plrExploding	; Non lo fa esplodere
	STA EnemyLineColorDefault
		LDA <#SoundGotFood
		STA SoundChannel0Ptr
		LDA >#SoundGotFood
		STA SoundChannel0Ptr+1
		JSR ActivateChannel0
	LDA #80
	STA ChangingDirection
	LDY #MAX_STRIPE
	LDA enemyX,Y
	STA SaveFirstEnemyX
	LDA playerX
	CMP #80		; Secondo la posizione del giocatore al momento che prende la frutta, posizioniamo il nemico che si viene a creare sulla prima linea
	BCC PlayerPos1
	LDA #16
	STA NewFirstEnemyX	; Nemico in posizione sinistra (16)
	JMP PlayerPos2
PlayerPos1
	LDA #110		; Nemico in posizione destra (110)
	STA NewFirstEnemyX

PlayerPos2

NoExploding
; -- Decrease fuel level --

	LDA plrStripe
	BEQ NoDecreaseFuel	; Don't decrease fuel if player is on base
	DEC FuelDelay
	BNE NoZeroFuelDelay
	; Decrease fuel level (and reset fuel delay)
	LDA #FUELDELAY_DEFAULT
	STA FuelDelay
	DEC FuelLevel
	LDA PfFuel+3
	BEQ Fuel4
	ASL
	STA PfFuel+3
	JMP NoZeroFuelDelay
Fuel4
	LDA PfFuel+4
	BEQ Fuel3
	LSR
	STA PfFuel+4
	JMP NoZeroFuelDelay
Fuel3
	LDA PfFuel+5
	BEQ Fuel2
	ASL
	STA PfFuel+5
	JMP NoZeroFuelDelay
Fuel2
	LDA PfFuel+2
	BEQ Fuel1
	LSR
	STA PfFuel+2
	JMP NoZeroFuelDelay
Fuel1
	LDA PfFuel+1
	BEQ Fuel0
	ASL
	STA PfFuel+1
	JMP NoZeroFuelDelay
Fuel0
	LDA PfFuel+0
	BEQ EndOfFuel
	LSR
	AND #%11000000
	STA PfFuel+0
	JMP NoZeroFuelDelay
EndOfFuel
	; Do something here if fuel has finished...
	LDA #1
	STA plrExploding
;	LDA #1
;	STA plrExploding	; weird alignment stuff.. humm.... must investigate
NoZeroFuelDelay

	LDA FuelLevel
	CMP #10
	BNE NoPlayerSlowDown
	LDA #3
	STA PlayerDelayDefault	; Slow down player if fuel is low
	LDA #FUELCOLOR_DANGER
	STA FuelColor
NoPlayerSlowDown
	CMP #15
	BNE NoChangeFuelColor
	LDA FuelColor
	CMP #FUELCOLOR_WARNING
	BEQ NoRestartFuelSound
	LDA #FUELCOLOR_WARNING
	STA FuelColor
	LDA <#SoundFuelWarning
	STA SoundChannel1Ptr
	LDA >#SoundFuelWarning
	STA SoundChannel1Ptr+1
	JSR ActivateChannel1
NoRestartFuelSound
NoChangeFuelColor
; -------------------------
NoDecreaseFuel
; --
; Joystick
	DEC PlayerDelay
	LDA PlayerDelay
;	BNE PlayerCanMoveX
	BEQ PlayerCanMoveX
	LDA Joystick0
	AND #%00111111
	STA Joystick0
;	DEC PlayerDelay
	JMP ContinueJoystick
PlayerCanMoveX
;	INC PlayerDelay		; Fino qui serve a far muovere sulle X a frames alterni
;	LDA #PLAYERDELAY_DEFAULT
	LDA PlayerDelayDefault
	STA PlayerDelay		; Fino qui serve a far muovere sulle X a frames alterni
ContinueJoystick	
	LDA Joystick0
;	AND #$F0
	BMI NoJoyRight
	LDX #148
	CPX playerX
	BEQ NoJoyRight
	; Azione RIGHT
	INC playerX
NoJoyRight
	ROL
	BMI NoJoyLeft
	LDX #12
	CPX playerX
	BEQ NoJoyLeft
	; Azione LEFT
	DEC playerX
NoJoyLeft
;-- Ignora UP/DOWN se nel frame precedente e' andato UP o DOWN
		TAX		; Se e' alla linea sotto la frutta, legge il joy su/giu' solo se e' allineato con la frutta
;			LDA GoingUp	; Legge su/giu' se si trova sulla prima riga e sta andando giu' (ossia se cerca di connettersi alla base)
;			BEQ CantConnectToBase
;			LDA #MIN_STRIPE
;			CMP plrStripe
;			BEQ OkJoyUpDown
;CantConnectToBase
		LDA GoingUp
		CMP #8
		BEQ ProcessJoyUpDown
		LDA plrStripe
		CMP #6
		BNE ProcessJoyUpDown
		LDY #MAX_STRIPE
		LDA enemyX,Y
		CMP playerX
		BEQ OkJoyUpDown
		CLC
		ADC #1
		CMP playerX
		BNE ProcessJoyUpDown
OkJoyUpDown
		LDA OldJoystick0
;		ORA #%00110000
		ORA #%00010000
		STA OldJoystick0
ProcessJoyUpDown
		TXA
;	TAX
	LDA OldJoystick0
	BIT J0_Up
	BEQ NoStick
	BIT J0_Down
	BEQ NoStick

	TXA
;--
	ROL
	BMI NoJoyDown
	LDX #MIN_STRIPE
	CPX plrStripe
	BCS MaybeNoJoyDown
	JMP OkJoyDown
MaybeNoJoyDown
	LDX GoingUp
;	BEQ NoJoyDown
	BEQ NoJoyUp
MaybeNoJoyDown2
	; Aggancio alla base - controllare posizione player, che sia allineato con la base...
	; e far avanzare di livello!
	TAX	; Save A
	LDA baseX
	CLC
	ADC #8
	CMP playerX
	;BCC NoJoyDown
	BCC NoJoyUp
	LDA baseX
	SBC #8
	CMP playerX
;	BCS NoJoyDown
	BCS NoJoyUp	; NoJoyDown AND NoJoyUp

	LDA baseX
	STA playerX	; Agganciamento: il player si posiziona sulla base
	;INC CurrentLevel	; Prossimo livello...
	LDA #1
	STA ChangeLevel	; Cambiare il livello!
;	LDX #0
;	STX GoingUp
	TXA	; Restore A
OkJoyDown
	; Azione DOWN
	DEC plrStripe
;	STA Temp
	LDA <#SoundMovePlayer
	STA SoundChannel0Ptr
	LDA >#SoundMovePlayer
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0
;	LDA Temp
	JMP NoStick
NoJoyDown
	ROL
	BMI NoJoyUp
	LDX #MAX_STRIPE
;		INX
	STA Temp
	CPX plrStripe
	BCC NoJoyUp
	; Azione UP
		STA Temp
		LDA GoingUp
		BNE OkJoyUp	; Se stiamo andando giu', permetti sempre di far andare il giocatore sulla prima fascia

		LDA plrStripe	; Se e' alla linea sotto la frutta, sposta in su solo se e' allineato con la frutta
		CMP #MAX_STRIPE
		BNE OkJoyUp
		TAY
		LDA GoingUp
		CMP #8
		BEQ NoJoyUp
			LDA MissileStripe
			BNE NoJoyUp
		LDA enemyX,Y
		CMP playerX
		BEQ OkJoyUp
		CLC
		ADC #1
		CMP playerX
		BNE NoJoyUp
OkJoyUp
	INC plrStripe
;	STA Temp
	LDA <#SoundMovePlayer
	STA SoundChannel0Ptr
	LDA >#SoundMovePlayer
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0
;	LDA Temp
NoJoyUp

NoStick
;	LDA INPT4	; Togliere il commento a queste 2 linee x leggere il pulsante di fuoco
;	BMI NoJoyFire
	; Azione del fuoco va qui
NoJoyFire

	LDA Joystick0
	STA OldJoystick0	; Salva la posizione del joy per il prossimo frame in modo che possiamo controllare com'era nel frame precedente

;	DEC spr0y
;	LDA spr0y
;	CMP #$02
;	BCS NoZeroSpr0Y		; BCS: Salta se A >= alla memoria
	;BPL NoZeroSpr0Y
	;BNE NoZeroSpr0Y
;	LDA #192
;	STA spr0y
;NoZeroSpr0Y	

; Movimento X Nemici
;	LDX spr0x	; Per ora calcoliamo una sola X per tutti i nemici...
;	JSR CalcSprXPos
;	STA HMP1
;	STY spr1pos

; Sposta i nemici secondo i Delay e gli Incrementi/Direzioni
; In enemyPatterns goes pattern number
; In enemyPatternsPtr pointer to the byte of the pattern

	LDY MAX_STRIPE
	LDX MAX_STRIPE
MoveEnemyX
	LDA enemyPatterns,X	; Load pattern number for this stripe
	ASL
	TAX
	INX
	LDA MovePatternPointers,X
	STA PatternPointerLo
	DEX
	LDA MovePatternPointers,X
	STA PatternPointerHi	; Load pointer to this pattern
	TYA
	TAX
	LDA enemyPatternsPtr,X
	TAY
	LDA (PatternPointerLo),Y	; Get pattern byte to be added to enemy X
	STA Temp
		DEC enemyPatternsPtr,X
		BNE NoZeroPattern
		LDY #0
		LDA (PatternPointerLo),Y
		STA enemyPatternsPtr,X
NoZeroPattern
	LDA enemyX,X
	CLC
	ADC Temp
	CMP #160
;	CMP #161
;	BCC NoZeroEnemyX
	BNE NoZeroEnemyX
	LDA #0
	JMP NoResetEnemyX
NoZeroEnemyX
;	CMP #1
;	CMP #0
	CMP #-1
;	BCS NoResetEnemyX
	BNE NoResetEnemyX
;	LDA #160
	LDA #159
NoResetEnemyX
	STA enemyX,X
NoMoveEnemyX

	STA enemyX,X
	TXA
	TAY
	DEX
	DEY
	BPL MoveEnemyX

; Movimento X Player
MovePlayerX
	LDX playerX
	JSR CalcSprXPos
	STA HMP0
	STA plrOff
	STY plrPos
; Copia la posizione del player in quella della base, ma solo se il player si trova sulla base! (ossia plrStripe = 0)
	LDA plrStripe
	BNE NoCopyPlayerBase
	LDA plrPos
	STA basePos
	LDA plrOff
	STA baseOff
	LDA playerX
	STA baseX
NoCopyPlayerBase

; Calcola i Movimenti X per tutte le fasce di Nemici
	LDX MAX_STRIPE
CalcEnemyX
	STX Temp
	LDA enemyX,X
	TAX
	JSR CalcSprXPos
	LDX Temp
	STA enemyOff,X
	STY enemyPos,X
	DEX
	BPL CalcEnemyX
	
NoSprAddPos
;	STA HMCLR	; Clear HMOVE
;	LDA spr0off	; 
;		INC spr0off
;		LDA spr0off

;	LDX ShiftTabPos
;	LDA ShiftTab,X
;	STA HMP0	; Shift X dello sprite 0
;	INC ShiftTabPos
;	LDA ShiftTabPos
;	AND #15
;	STA ShiftTabPos

	;LDA #0
	;STA Spr0ClrCnt

;	LDA #192
;	STA ScreenY

; Animazione Player 1
;	LDA GoingUp
;	BNE PlayerNormalAnim	; Se c'e' collisione ma GoingUp sta ad 1 vuol dire che il giocatore sta andando verso il basso
; Esplosione?
	LDA #0
	STA plrNextLife		; We have to zero this, somewhere... it's just a one-time switch!

	LDA plrExploding
	BEQ PlayerNormalAnim	; Se non sta esplodendo...
	; Sta esplodendo: animazione e suono
	LDA PlayerDeath1Anim
	CMP plrDeathAnim
	BNE NoStartExplosionSound
	JSR StopSounds
	LDA <#SoundPlayerExplode
	STA SoundChannel0Ptr
	LDA >#SoundPlayerExplode
	STA SoundChannel0Ptr+1
	JSR ActivateChannel0
	DEC plrLives		; Decrease lives counter
	BNE NoStartExplosionSound	; End of lives?
	LDA #6
	STA GameScreen
	JSR StopSounds

NoStartExplosionSound
	LDX plrDeathAnim
	LDA PlayerDeath1Anim,X
	STA plrAnimOff
	DEC plrDeathAnim
	BNE NoZeroPlayerAnim

	LDA PlayerDeath1Anim
	STA plrDeathAnim	; Resets death animation
	LDA Player1Anim
	STA plrAnim
	LDA #0
	STA plrExploding	; end of explosion
	JSR StopSounds
;	DEC plrLives		; Decrease lives counter
		LDA #0
		STA GoingUp
		;LDA #FUELLEVEL_DEFAULT
		;STA FuelLevel
		;LDA FUELDELAY_DEFAULT
		;STA FuelDelay
		;JSR PlayerDeath
		JSR InitFuel
;	LDA #1
;	STA plrNextLife
	LDA #ENEMYLINECOLOR_DEFAULT
	STA EnemyLineColorDefault
	LDA #INITIAL_STRIPE
	STA plrStripe	; Fascia in cui si trova il giocatore
	LDA baseX
	STA playerX

	; Next Life

	JMP NoZeroPlayerAnim
PlayerNormalAnim	; Animazione normale del player (non esplosione)
	LDX plrAnim
	LDA Player1Anim,X
	STA plrAnimOff
	DEC plrAnim
	BNE NoZeroPlayerAnim
	LDA Player1Anim
	STA plrAnim

NoZeroPlayerAnim

	LDA #1
	STA VDELP0	; Questo serve per abbassare di una linea P0 senno' si disallinea da P1 dato che disegno uno sprite su una linea e uno sull'altra

	LDA MissileStripe
	BNE NoZeroColToAdd
	LDA #0
	STA ColToAdd
NoZeroColToAdd
	RTS

; ----- Player Dies: reset veriables... -----
;PlayerDeath
;	JSR InitFuel
;	RTS

; ----- Initialize fuel level and graphics -----
InitFuel
;	LDA #%11000000
;	STA PfFuel+0
;	LDA #%11111111
;	STA PfFuel+1
;	LDA #%11111111
;	STA PfFuel+2
;	LDA #%11000000
;	STA PfFuel+3
;	LDA #%11111111
;	STA PfFuel+4
;	LDA #%11111111
;	STA PfFuel+5

	LDA #%11000000
	STA PfFuel+0
	STA PfFuel+3
	LDA #%11111111
	STA PfFuel+1
	STA PfFuel+2
	STA PfFuel+4
	STA PfFuel+5

	LDA #FUELLEVEL_DEFAULT
	STA FuelLevel
	LDA #FUELDELAY_DEFAULT
	STA FuelDelay

	LDA #FUELCOLOR_OK
	STA FuelColor
	RTS

;
; This is the scariest thing I've done all month.
;
DrawScreen ;**************************** SCREEN DRAWING ROUTINES
	LDA INTIM
	BNE DrawScreen ; Whew!
	STA WSYNC
;	STA HMOVE
	STA VBLANK  ;End the VBLANK period with a zero.
;
; Now we can do what we need to do.  What sort of playfield do
; we want to show?  A doubled playfield will work better than
; anything if we either want a side scroller (which involves some
; tricky bit shifting, usually) or an asymmetrical playfield (which
; we're not doing yet).  A mirrored playfield is usually best for
; vertical scrollers.  With some creativity, you can use both in your
; game.
;
; The "score" bit is useful for drawing scores with playfield graphics
; as Combat and other early games do.  It can also create a neat effect
; if you know how to be creative with it.  One useful application of
; score mode would be always having player 1 on the left side, and
; player 0 on the right side.  Each player would be surrounded in the
; opposite color, and the ball graphic could be used to stand out
; against either one.  On my 2600jr, color from the right side bleeds
; about one pixel into the left side, so don't think it's perfect.
; It's really far from perfect because PC Atari does not implement
; it at all; both sides appear as Player 0's color.  A26 does, though.
;
; To accomodate this, my routine puts color values into
; COLUP0 for the left side, and COLUP1 for the right side.  Change
; the LDA operand to 0 or 1 to use the normal system.  The code in
; the scanning loop accounts for both systems.
;
	;LDA  #2
	LDA  #5		; Playfield tutto dello stesso colore
	STA  CTRLPF
;
; Initialize some display variables.
;

; 192 Scanlines

; Prima linea: inizializziamo un po' di cose...
	LDA #$23
	STA COLUP0
	LDA #0
	STA GRP0	; Sprite 0 nullo
	STA PF1
	STA PF2
	STA COLUPF	; Background nero
	LDA #%00110000
	STA PF0

; -- Inizio Fasce --
	LDA TOTAL_STRIPES	; 7
;	CLC
;	SBC #1	; Una fascia in meno perche' la prima la gestiamo a parte..
	STA Stripes	; Numero di fasce

; Position missile
	;JSR LeftRandom
	;AND #7
	;TAY
	;LDA MissileXPos,Y
	;LDX #5
	;LDA #5
	;LDA random	; Missile0 X position (just the POS)
	;AND #7
	;SBC #2
	;AND #%00001111
	;AND #%00000111
	LDX MissileXPos
	;TAX
	;LDA #%00000010
	LDA #0
	STA WSYNC
Missile0XposLoop1
	DEX
	BPL Missile0XposLoop1
	STA ENAM0	; Enable (or disable) missile 0 graphics
	STA RESM0
	STA WSYNC		; Arriva alla fine della linea

StripesLoop
; ----------- Fascia ------------
;	LDX spr0pos
;	LDY spr1pos

; Caricamento Offset e Pos Nemici (da array) e Player. Player solo POS.
	LDX Stripes
	DEX
	LDA enemyOff,X
	STA HMP1
	LDY enemyPos,X

	;LDY spr1pos	; Sprite 1 pos (nemici)
	LDX plrPos	; Sprite 0 pos (player)
	STA WSYNC

; Posizioniamo i nostri sprites...
Spr0XposLoop1
	DEX
	BPL Spr0XposLoop1
	STA RESP0	; Attiva lo sprite a questa pos. secondo i cicli passati
	STA WSYNC		; Arriva alla fine della linea

Spr1XposLoop1
	DEY
	BPL Spr1XposLoop1
	STA RESP1	; Attiva lo sprite a questa pos. secondo i cicli passati
	STA WSYNC		; Arriva alla fine della linea
	STA HMOVE

; --- 8 scanlines * 2
	LDA #192
	STA ScreenY
	LDA #8
	STA ScreenStripeY

	LDA Stripes	; 8
	CLC
;	SBC #1	; 7
	ASL	; 7*2 = 14
	LDX GoingUp		; 8 if going up, 0 if going down
	BEQ PlayerGoingDown	; If GoingUp == 0 the player is going down!
;	LDY Stripes
;	CPY #7
	CMP #14
	BNE PlayerGoingDown
;	CLC
;	SBC #1
	LDA #13
PlayerGoingDown
;	ASL		;
;	ASL		; Multiply stripe number by 4 and obtain level data pointer
;	TAY
;	DEY
	TAX
	DEX

	; OUCH! Must optimize...!
	LDA LevelData,X		; Load number pointing to shape number (e.g. 0, 1, 2..)
	STX Temp

;	LDX #0
	LDY #0

;	CLC
	ASL	; *2
	BCC TranslateShapes1
	INY
TranslateShapes1
	TAX	; X: lo
	TXA

;	CLC
	ASL	; *4
	BCC TranslateShapes2
	INY
TranslateShapes2
	TAX	; X: lo
	TXA

;	CLC
	ASL	; *8
	BCC TranslateShapes3
	INY
TranslateShapes3
	TAX	; X: lo
	TXA

;	CLC
	ASL	; *16
	BCC TranslateShapes4
	INY
TranslateShapes4
;	TAX	; X: lo
	CLC
	ADC #<EnemyShapes
	TAX
	TYA
	ADC #>EnemyShapes

	STA enemyShapeHi
	STX enemyShapeLo

	LDX Temp
	DEX
	LDA LevelData,X
;	CPX #(MAX_STRIPE*2)-1
	LDY Stripes
;	DEY
	CPY #MAX_STRIPE + 1
	BNE NormalNuSiz
;	BCS NormalNuSiz
	LDA #0
NormalNuSiz
	STA NUSIZ1
	LDX plrAnimOff	; Offset Player
	LDY #0	; Offset Nemico

;	DEC ScreenStripeY
;	STA WSYNC
ScanLoop1
;	LDA ScreenStripeY
;	CMP #1
;	BNE NoBgColor
;	LDA EnemyLineColor
;	STA COLUBK
;NoBgColor
	LDA Stripes
	CMP plrStripe
	BNE NoDrawPlayer
	LDA Player1Shape,X
	STA GRP0	; store this line of data in player graphic 0 register. Questo lo posso fare quando voglio e rimane... l'importante e' scrivere in RESP0 al momento che voglio la linea dello sprite!
NoDrawPlayer
	INX

;		LDA ScreenStripeY
;		CMP #1
;		BNE NoColToAdd
;		LDA EnemyLineColorDefault
;		STA ColToAdd
;NoColToAdd

	STA WSYNC

	LDA Player1Shape,X
	STA COLUP0
;	LDA Mine1Shape,Y
	LDA (enemyShapeLo),Y
	STA GRP1	; Se VDELP0 e' attivo, lo sprite 0 verra' mostrato solo al momento della scrittura in GRP1 !!! cosi' compaiono entrambi gli sprites sulla stessa scanline... ma ocio ai colori!
	INY
;	LDA Mine1Shape,Y	; 4
	LDA (enemyShapeLo),Y
	STA COLUP1
	STA Temp
;	LDA Player1Shape,X
;	STA COLUP0

	INX
	INY
	; -- Missile
	LDA Stripes
	CMP MissileStripe		; Stripe to draw the missile on
	BNE NoDrawMissile
	LDA ScreenStripeY
	CLC
	SBC #MISSILE_TOP	; Missile Top
	BPL NoDrawMissile
	LDA ScreenStripeY
;	CLC
	SBC #MISSILE_HEIGHT	; Missile Height
	BMI NoDrawMissile
	LDA #2
	STA ENAM0
	JMP SkipZeroMissile
NoDrawMissile
	LDA #0
	STA ENAM0
SkipZeroMissile
	STA WSYNC

	LDA ScreenStripeY
	CMP #1
	BNE NoBgColor
	LDA EnemyLineColor
	STA COLUBK
	LDA Temp
	;CLC
	ADC ColToAdd
	STA COLUP1
NoBgColor

	DEC ScreenStripeY
	BNE ScanLoop1
	STA WSYNC	; Un'altra linea...

	LDA #0
	STA GRP0
	STA GRP1
	;	LDA #0
	;	STA ColToAdd
; ----- Fine Fascia -----

;	LDA #0
	STA COLUBK
	STA EnemyLineColor
	STA ENAM0
	STA ColToAdd
	
;	LDA Stripes
;	CMP #3
;	BNE NoDrawMissile2
;	LDA #2
;	STA ENAM0
;NoDrawMissile2

;	LDA #%00000110	; 3 sprite, distanza massima
;	STA NUSIZ1

;		INC spr0pos
	DEC Stripes	; Finita una fascia
	BEQ EndStripesLoop	; Jump al loop delle fasce
	JMP StripesLoop
EndStripesLoop
; ------------------- Terreno ---------------------
;	LDA #%00000000
;	STA NUSIZ1
	LDX basePos	; Sprite 0 pos (player)
	LDA baseOff
	STA HMP0
	STA WSYNC

Spr0XposLoop2
	DEX
	BPL Spr0XposLoop2
	STA RESP0	; Attiva lo sprite a questa pos. secondo i cicli passati
	STA WSYNC		; Arriva alla fine della linea
	STA HMOVE

	LDA #8
	STA ScreenStripeY
	;LDX plrAnimOff	; Offset Player
	LDX #0
	LDA plrStripe
	BEQ ScanLoop2
	LDX #16		; Se il player e' in una fascia diversa dalla base, prende il frame 2 della base, ossia quello vuoto

ScanLoop2
	LDA PlayerGround1Shape,X
	;STA GRP0	; store this line of data in player graphic 0 register. Questo lo posso fare quando voglio e rimane... l'importante e' scrivere in RESP0 al momento che voglio la linea dello sprite!
	STA GRP0
	INX
	STA WSYNC
	LDA PlayerGround1Shape,X
	STA COLUP0
	INX
	LDA #0
	STA GRP1
	STA WSYNC

	DEC ScreenStripeY
	BNE ScanLoop2

	STA WSYNC
	LDA #0
	STA GRP0
	STA GRP1

; -- Terreno vero e proprio
	; Should do a loop for this:
	LDA #$f4
	STA COLUBK
	STA WSYNC
	LDA #$fa
	STA COLUBK
	STA WSYNC
	LDA #$f8
	STA COLUBK
	STA WSYNC
	LDA #$f4
	STA COLUBK
	STA WSYNC
	LDA #$00
	STA COLUBK
;	LDX #7
;	LDX #0
	TAX	; LDX #0

;	LDA #0
	STA PF0
	STA PF1
	STA PF2
	;LDA #$d4
	LDA FuelColor
	STA COLUPF	; Removing PF graphics and blanking line 1 scanline before doing the fuel in order to maintain a correct cycle count
	STA WSYNC

; -------------------
;	LDA #$d4
;	STA COLUPF

;	STA WSYNC

	LDA PfFuel,X	; 3
	STA PF0		; 6
	LDA PfFuel+1,X	; 9
	STA PF1		; 12
	LDA PfFuel+2,X	; 15
	STA PF2		; 18

	NOP
	NOP
	NOP

	LDA PfFuel+3,X	; 3
	STA PF0		; 6
	LDA PfFuel+4,X	; 9
	STA PF1		; 12
	LDA PfFuel+5,X	; 15
	STA PF2		; 18


;	LDA PFData0,X           ;[0]+4
;	STA PF0                 ;[4]+3 = *7*   < 23	;PF0 visible
;	LDA PFData1,X           ;[7]+4
;	STA PF1                 ;[11]+3 = *14*  < 29	;PF1 visible
;	LDA PFData2,X           ;[14]+4
;	STA PF2                 ;[18]+3 = *21*  < 40	;PF2 visible

;	nop			;[21]+2
;	nop			;[23]+2
;	nop			;[25]+2
	
;	LDA PFData0b,X          ;[27]+4
;	STA PF0                 ;[31]+3 = *34* 
;	LDA PFData1b,X		;[34]+4
;	STA PF1			;[38]+3 = *41*  
;	LDA PFData2b,X		;[41]+4
;	STA PF2			;[45]+2 = *47*  ; > 46 PF2 no longer visible

	STA WSYNC

; ---- Finish screen...
	LDA #00
	STA COLUPF
	LDA #%00110000	; Restore black border...
	STA PF0
	LDA #0
	STA PF1
	STA PF2
	STA COLUBK

	STA HMCLR
	STA WSYNC	; black line after fuel

	LDA #$f2
	STA COLUBK
;	STA WSYNC

; ---- Lives Indicator -----

;	LDA #$00
;	STA VDELP0

	LDA plrLives
	;AND #7
;	CLC
	ASL
;	SBC #1
	TAX
	DEX
;	LDY #1
;LoadLivesDisplayData
	LDA LivesDisplayData,X
	STA NUSIZ0
	DEX
	LDA LivesDisplayData,X
	STA NUSIZ1
;	DEX
;	DEY
;	BPL LoadLivesDisplayData

;	LDA #3
;	STA NUSIZ0
;	STA NUSIZ1

	LDA #$80
	STA HMP0
	LDA #$82
	STA HMP1

	LDY #9	; Lives sprite length
; Position sprite
	
	LDX #3
	STA WSYNC
Spr0XposLoopLives
	DEX
	BPL Spr0XposLoopLives
	STA RESP0
	BIT $00
	BIT $00
	BIT $00
	NOP
	NOP
	STA RESP1
	STA WSYNC
	STA HMOVE

	LDX plrLives
DrawLivesSprite
	LDA LivesSprite1,Y
	CPX #0
	BNE OkLivesSprite0
	LDA #0
OkLivesSprite0
	STA GRP0
	STA WSYNC
	LDA LivesSprite1,Y
	CPX #4
	BCS OkLivesSprite1
	LDA #0
OkLivesSprite1
	STA GRP1
	DEY
	LDA LivesSprite1,Y
	STA COLUP0	; Se VDELP0 e' attivo, lo sprite 0 verra' mostrato solo al momento della scrittura in GRP1 !!! cosi' compaiono entrambi gli sprites sulla stessa scanline... ma ocio ai colori!
	STA COLUP1
	STA WSYNC
;	STA WSYNC
	DEY
	BPL DrawLivesSprite
	STA WSYNC

EndDrawLives
	LDA #0
	STA GRP0
	STA GRP1
	LDA #%00100000
	STA NUSIZ0

;	LDA #$01
;	STA VDELP0

; ---- End of screen ----

;	LDY #13		; Scanlines to finish screen
;	LDY #11		; Scanlines to finish screen
	LDY #3		; Scanlines to finish screen

EndScreenLoop
	STA WSYNC
	DEY
	BNE EndScreenLoop

;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP

;	NOP
;	NOP

;
; Clear all registers here to prevent any possible bleeding.
;

;	LDA #2
;	STA WSYNC  ;Finish this scanline.
;	STA VBLANK ; Make TIA output invisible,
	; Now we need to worry about it bleeding when we turn
	; the TIA output back on.
	; Y is still zero.
;	LDY 0

;	STY PF0
;	STY PF1
;	STY PF1
;	STY GRP0
;	STY GRP1
;	STY ENAM0
;	STY ENAM1
;	STY ENABL
	RTS

;
; For the Overscan routine, one might take the time to process such
; things as collisions.  I, however, would rather waste a bunch of
; scanlines, since I haven't drawn any players yet.
;
OverScan   ;***************************** OVERSCAN CALCULATIONS

; -- First, do vblank and clear some stuff
	LDA #2
	STA WSYNC  ;Finish scanline 192.
	STA VBLANK ; Make TIA output invisible,
	;
	LDY #0
	STY PF0
	STY PF1
	STY PF1
	STY GRP0
	STY GRP1
	STY ENAM0
	STY ENAM1
	STY ENABL

; -- Read Collisions
	LDX #30

	LDA CXPPMM		; Player with player
	;STA plrCollide
	BPL NoCollisions1
	LDA plrNextLife
	BNE NoCollisions1
	LDA #1
	STA plrExploding
NoCollisions1
	LDA CXM0P		; Player with missile (picked up key)
	ASL
	BPL NoCollisions2
	LDA #0
	STA MissileStripe
	LDA <#SoundGetKey
	STA SoundChannel1Ptr
	LDA >#SoundGetKey
	STA SoundChannel1Ptr+1
	JSR ActivateChannel1
	DEX
NoCollisions2

	STA CXCLR	; Resetta le collisioni dopo averle lette
; --

;	LDX #30
KillLines
	STA WSYNC
	DEX
	BNE KillLines
	RTS

;
; GameInit could conceivably be called when the Select key is pressed,
; or some other event.
;
GameInit
	LDA #0
	STA CurrentLevel
	STA LevelCounter
	STA LevelCounter+1
	INC LevelCounter+1	; 1st level: display 01 instead of 00

	LDA PLAYER_INITIALLIVES
	STA plrLives

;	LDA #RAND_SEED
;	STA random

;	JSR NewLevel

	RTS

; ------------------------------------------------
; ----------- David Crane's LeftRandom -----------
; ------------------------------------------------

; Y: number to pick from the list (e.g. 0 = 1st number)
LeftRandom
loopRandom:
; random' = random >> 1 | (bit4^bit5^bit6^bit1) * $80
	lda    random           ; 3
	asl                     ; 2
	eor    random           ; 3
	asl                     ; 2
	eor    random           ; 3
	asl                     ; 2
	asl                     ; 2
	rol                     ; 2
	eor    random           ; 3
	lsr                     ; 2
	ror    random           ; 5
;	dey                     ; 2
;	bpl    loopRandom      ; 2
	RTS

; ------------------------------------------------
; --------- Inizializza un nuovo livello ---------
; ------------------------------------------------

NewLevel
;	INC CurrentLevel
	LDA CurrentLevel
	CMP #TOTAL_LEVELS
	BCC NoResetLevels
; -- Resets levels count --
	LDA #0
	STA CurrentLevel
	STA LevelCounter
	STA LevelCounter+1
	INC LevelCounter+1	; 1st level: display 01 instead of 00
NoResetLevels
	LDA #0

        STA     GRP0	; clear out player graphic 0
        STA     GRP1	; clear out player graphic 1
        STA     ENAM0	; clear out missile 0
        STA     ENAM1	; clear out missile 1
        STA     ENABL	; clear out ball

	STA spr0off

	STA GoingUp
	STA plrExploding
	STA plrNextLife
	STA ChangingDirection

	LDA #5
	STA spr0x

	LDA #INITIAL_STRIPE
	STA plrStripe	; Fascia in cui si trova il giocatore

	LDA #$F0
	STA OldJoystick0

	LDA #PLAYERX_DEFAULT	; Pixel iniziale X sprite player
	STA playerX

	LDA #ENEMYLINECOLOR_DEFAULT
	STA EnemyLineColorDefault
	STA ColToAdd

; -- KEY/MISSILE
	; -- Randomize Missile Stripe position
	JSR LeftRandom
	LDA random
	AND #7
	TAY
	LDA MissileStripePos,Y
	STA MissileStripe
	; -- Randomize Missile X position
	JSR LeftRandom
	LDA random
	AND #7
	TAY
	LDA MissileXPosTable,Y
	STA MissileXPos

; -- Fill in level data
; First 2 bytes of level data
	LDX #13
	;JSR LeftRandom
	;LDA random	; Treat
;	AND #15
	LDA CurrentLevel	; Make treats cycle and not random...
	AND #7
;	AND #3
	CLC
	ADC #ENEMY_SHAPES_NUMBER	; Point to treat shape instead of enemy shape
	STA LevelData,X
	DEX
	JSR LeftRandom
	LDA random	; Treat replacement
	AND #15
;	AND #7
	STA LevelData,X
	DEX
LoadLevelTemp2
	JSR LeftRandom
	LDA random
	AND #15
;	AND #7
	STA LevelData,X
	DEX
;	LDA #6		; NUSIZ
	JSR LeftRandom
	LDA random
	AND #7
	TAY
	LDA CurrentLevel
	CMP #LEVELS_EASY
	BCS Level2Nusiz
	LDA NuSizList1,Y
	JMP ContinueLevelNusiz
Level2Nusiz
	CMP #LEVELS_MEDIUM
	BCS Level3Nusiz
	LDA NuSizList2,Y
	JMP ContinueLevelNusiz
Level3Nusiz
	LDA NuSizList3,Y
ContinueLevelNusiz
	STA LevelData,X
	DEX
	BPL LoadLevelTemp2

; -- Inizializza l'animazione del player 1
	LDA Player1Anim
	STA plrAnim

; -- Init enemy patterns
; -> Far muovere i nemici a linee alterne verso dx e sx
; -> Farli uno del livello attuale ed uno di quello precedente
; In enemyPatterns goes pattern number
; In enemyPatternsPtr pointer to the last byte of the pattern
	LDY MAX_STRIPE
	JSR LeftRandom
	LDA random
	AND #3			; For the treat, only pick simple movement patterns (one of the first 4)
;		LDA #0
	STA enemyPatterns,Y
	ASL
	TAX
	INX
	LDA MovePatternPointers,X
	STA PatternPointerLo
	DEX
	LDA MovePatternPointers,X
	STA PatternPointerHi
	STY Temp
	LDY #0
	LDA (PatternPointerLo),Y
	LDY Temp
	STA enemyPatternsPtr,Y
	LDA enemyPatterns,Y
	DEY
; For the first line after the treat, always pick the pattern after the one of the treat
; (so the line moves on the opposite direction)
	CLC
	ADC #1
	AND #3
	STA enemyPatterns,Y
		STA FuelLevel
	ASL
	TAX
	INX
	LDA MovePatternPointers,X
	STA PatternPointerLo
	DEX
	LDA MovePatternPointers,X
	STA PatternPointerHi
	STY Temp
	LDY #0
	LDA (PatternPointerLo),Y
	LDY Temp
	STA enemyPatternsPtr,Y
	DEY

;	LDA #0
;	STA FuelLevel
NewLevel_InitPatterns
	;LDA #0
	JSR LeftRandom
	LDA random
	LDX CurrentLevel
;	CLC
;	CPX #1
	CPX #LEVELS_EASY
	BCS Level2Patterns
	AND #3		; Easy level
	LDX #0
	STX MissileStripe	; No key on easy levels...
	JMP ContinueLevelPatterns
Level2Patterns
;	CLC
;	CPX #2
	CPX #LEVELS_MEDIUM
	BCS Level3Patterns
	AND #7		; Medium level
	JMP ContinueLevelPatterns
Level3Patterns
;	AND #15
	AND #7		; Hard level
	CLC
	ADC #8
ContinueLevelPatterns
;	AND #3
;	AND #7
		LDX FuelLevel	; Reuse of FuelLevel as a temporary variable
		STA FuelLevel
		CPX FuelLevel
		BEQ NewLevel_InitPatterns
	STA enemyPatterns,Y
	ASL
	TAX
	INX
	LDA MovePatternPointers,X
	STA PatternPointerLo
	DEX
	LDA MovePatternPointers,X
	STA PatternPointerHi
	STY Temp
	LDY #0
	LDA (PatternPointerLo),Y
	LDY Temp
	STA enemyPatternsPtr,Y
	DEY
	BPL NewLevel_InitPatterns

; -- Init enemy X starting positions (random)
	LDY MAX_STRIPE
	LDX #0
NewLevel_InitEnemyX
;	LDA EnemyPositions,Y
	JSR LeftRandom
	LDA random
;	LDA #0
	CMP #159			; If the enemy x is >= 160, make it wrap
	BCC NewLevel_NoChangeEnemyX
	CLC
	SBC #159
	ADC #1
NewLevel_NoChangeEnemyX
	CMP #0				; Never choose 0 for enemy x
	BNE NewLevel_NoChangeEnemyX2
	CLC
	ADC #1
NewLevel_NoChangeEnemyX2
	STA enemyX,X
	INX
	DEY
	BPL NewLevel_InitEnemyX
; --

	LDA PLAYERDELAY_DEFAULT
	STA PlayerDelayDefault
	STA PlayerDelay

;	LDA PLAYER_INITIALLIVES
;	STA plrLives

	LDA PlayerDeath1Anim
	STA plrDeathAnim	; Resetta l'animazione della morte

;	LDA #0
	STA ChangeLevel

	;LDA #%00000101
	;LDA #%00000011
	;LDA #%00000110	; 3 sprite, distanza massima
	LDA #%00000001
	;LDA #%00000000	; 1 sprite
	STA NUSIZ1
	;STA NUSIZ1

	LDY #%00100000
	STY NUSIZ0

	JSR InitFuel

	JSR StopSounds
	;LDA #-1
	;STA SoundChannel0Cnt
	;STA SoundChannel1Cnt

	LDA #$01
	STA VDELP0
	LDA #$00
	STA VDELP1
	STA ChangeLevel

	RTS

SetLevelPointers
         ;make pointers to num data
	ldx #1	; Number of score bytes (0-1)
	ldy #2	; Points to the last score pointer
LevelCounterLoop
	lda LevelCounter,x	; Load last byte of level number (in 01, would load 1)
        asl 
	asl 
	asl	; Multiply score digit by 8 (as a sprite in rom is 8 bytes long)

	CLC
	adc #<Number0	; Add the byte to the low byte of first pointer to number shapes
	sta ptr4,y	; And store it in the ptr data
	lda #0
	adc #>Number0	; Add the carry, if any, to the high byte of shape pointer
	sta ptr4+1,y	; And store it in the ptr data
	dey
	dey		; Next (previous) pointer
	dex		; Next (previous) byte of level number
	bpl LevelCounterLoop	; Loop
	JMP MainLoopLevelScreen
;	RTS

	
; Shape, Color
EnemyShapes
Rock1Shape
	.byte %00111000, $20
	.byte %01001110, $22
	.byte %10111111, $24
	.byte %11111110, $24
	.byte %01111111, $24
	.byte %01111110, $22
	.byte %00011000, $20
	.byte %00000000, $00

Mine1Shape
	.byte %00011000, $14
	.byte %10111101, $16
	.byte %01111110, $18
	.byte %10101011, $18
	.byte %11010101, $18
	.byte %01111110, $18
	.byte %10111101, $16
	.byte %00011000, $14

Ufo1Shape
	.byte %00000000, $00
	.byte %01000010, $40
	.byte %00111100, $42
	.byte %11100111, $46
	.byte %11100111, $46
	.byte %00111100, $42
	.byte %01000010, $40
	.byte %00000000, $00

Ship1Shape
	.byte %10000001, $b4
	.byte %11000011, $b6
	.byte %11011011, $b8
	.byte %11111111, $ba
	.byte %11111111, $ba
	.byte %11011011, $b8
	.byte %11000011, $b6
	.byte %10000001, $b4

Cube1Shape
	.byte %00111111, $a8
	.byte %01100011, $aa
	.byte %11111101, $ac
	.byte %10100101, $ae
	.byte %10100101, $ae
	.byte %10111111, $ac
	.byte %11000110, $aa
	.byte %11111100, $a8

Ball1Shape
	.byte %00011000, $c2
	.byte %00101100, $c4
	.byte %01011110, $c6
	.byte %10111111, $c8
	.byte %11111111, $c8
	.byte %01111110, $c6
	.byte %00111100, $c4
	.byte %00011000, $c2

Circle1Shape
	.byte %00111100, $92
	.byte %01000010, $94
	.byte %10011001, $96
	.byte %10100101, $98
	.byte %10100101, $98
	.byte %10011001, $96
	.byte %01000010, $94
	.byte %00111100, $92

Vertical1Shape
	.byte %00011000, $52
	.byte %00011000, $54
	.byte %00111100, $56
	.byte %11111111, $58
	.byte %11111111, $58
	.byte %00111100, $56
	.byte %00011000, $54
	.byte %00011000, $52

Star1Shape
	.byte %00011000, $e2
	.byte %01011010, $e4
	.byte %00111100, $e6
	.byte %11111111, $e8
	.byte %11111111, $e8
	.byte %00111100, $e6
	.byte %01011010, $e4
	.byte %00011000, $e2

Ship2Shape
	.byte %00100100, $22
	.byte %01100110, $24
	.byte %11111111, $26
	.byte %11100111, $28
	.byte %11100111, $28
	.byte %11111111, $26
	.byte %01100110, $24
	.byte %00100100, $22

Spike1Shape
	.byte %10000001, $22
	.byte %01100110, $24
	.byte %01011010, $26
	.byte %00100100, $28
	.byte %00100100, $28
	.byte %01011010, $26
	.byte %01100110, $24
	.byte %10000001, $22

Spike2Shape	; n. 12
	.byte %10011001, $32
	.byte %01100110, $34
	.byte %01111110, $36
	.byte %10111101, $38
	.byte %10111101, $38
	.byte %01111110, $36
	.byte %01100110, $34
	.byte %10011001, $32

Ship3Shape	; n. 13
	.byte %00011000, $72
	.byte %01100110, $74
	.byte %11111111, $76
	.byte %00011000, $78
	.byte %00011000, $78
	.byte %11111111, $76
	.byte %01100110, $74
	.byte %00011000, $72

;Ship3Shape	; n. 14
	.byte %00100100, $b2
	.byte %00111100, $b4
	.byte %11111111, $b6
	.byte %01100110, $b8
	.byte %01100110, $b8
	.byte %11111111, $b6
	.byte %00111100, $b4
	.byte %00100100, $b2

;Ship3Shape	; n. 15
	.byte %11111111, $42
	.byte %00111100, $44
	.byte %01100110, $46
	.byte %11111111, $48
	.byte %11111111, $48
	.byte %01100110, $46
	.byte %00111100, $44
	.byte %11111111, $42

;Ship3Shape	; n. 16
	.byte %00111100, $c2
	.byte %01111110, $c4
	.byte %00011000, $c6
	.byte %11111111, $c8
	.byte %11111111, $c8
	.byte %00011000, $c6
	.byte %01111110, $c4
	.byte %00111100, $c2


TreatShapes
Strawberry1Shape
	.byte %00110100, $e6
	.byte %00011000, $e6
	.byte %00101100, $44
	.byte %01111010, $44
	.byte %01011110, $44
	.byte %00101100, $44
	.byte %00011000, $42
	.byte %11111111, $00

Cherry1Shape
	.byte %01100000, $e6
	.byte %00010000, $e6
	.byte %00001000, $e6
	.byte %00001000, $e6
	.byte %00011000, $44
	.byte %00111100, $44
	.byte %00011000, $44
	.byte %11111111, $00

Banana1Shape
	.byte %00011000, $f6
	.byte %00001100, $1a
	.byte %00001110, $1a
	.byte %00001110, $1a
	.byte %00001110, $1a
	.byte %00011100, $1a
	.byte %00110000, $1a
	.byte %11111111, $00

Drink1Shape
;	.byte %00000010, $0c
;	.byte %00000100, $0c
;	.byte %01111110, $ac
;	.byte %01001010, $ac
;	.byte %01010010, $ac
;	.byte %01111110, $ac
;	.byte %00111100, $ac
;	.byte %11111111, $00

	.byte %00110000, $f2
	.byte %00011000, $f2
	.byte %00111000, $e4
	.byte %01111100, $e4
	.byte %11111110, $e4
	.byte %11111110, $e4
	.byte %01101100, $e4
	.byte %11111111, $00

CandyBar1Shape	; n. 5
	.byte %01111000, $0f
	.byte %11001100, $42
	.byte %11001100, $0f
	.byte %00001100, $42
	.byte %00001100, $0f
	.byte %00001100, $42
	.byte %00001100, $0f
	.byte %11111111, $00


WaterMelon1Shape
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %11111011, $42
	.byte %10111111, $40
	.byte %01110110, $40
	.byte %00111100, $c2
	.byte %11111111, $00

;Candy1Shape	; n. 7
	.byte %00000000, $00
	.byte %10000001, $42
	.byte %11011011, $44
	.byte %11111111, $46
	.byte %11011011, $44
	.byte %10000001, $42
	.byte %00000000, $00
	.byte %11111111, $00

;CandyBar1Shape	; n. 8
	.byte %01111100, $ae
	.byte %11111110, $ae
	.byte %11111110, $ae
	.byte %11111110, $f6
	.byte %01111100, $f6
	.byte %00111000, $f6
	.byte %00010000, $f4
	.byte %11111111, $00

Player1Shape
;	.byte 2, 4	; Numero frames animazione, velocita' animazione (delay in frames)
; Frame 1
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01111110, $8a
	.byte %11011011, $8a
	.byte %11011011, $8a
	.byte %01111110, $8a
	.byte %10111101, $86
	.byte %01011010, $82
; Frame 2
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01111110, $8a
	.byte %11100111, $8a
	.byte %11100111, $8a
	.byte %01111110, $8a
	.byte %10111101, $86
	.byte %01011010, $82

PlayerExplosion1Shape	; Deve essere consecutivo a Player1Shape
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01100110, $8a
	.byte %11000011, $8a
	.byte %11000011, $8a
	.byte %01100110, $8a
	.byte %10111101, $86
	.byte %01011010, $82

	.byte %10011001, $82
	.byte %00100100, $86
	.byte %01000010, $8a
	.byte %10011001, $8a
	.byte %10011001, $8a
	.byte %01000010, $8a
	.byte %00100100, $86
	.byte %10011001, $82

	.byte %00011000, $82
	.byte %00000000, $86
	.byte %00011000, $8a
	.byte %10100101, $8a
	.byte %10100101, $8a
	.byte %00011000, $8a
	.byte %00000000, $86
	.byte %00011000, $82

	.byte %00000000, $82
	.byte %00011000, $86
	.byte %00000000, $8a
	.byte %01000010, $8a
	.byte %01000010, $8a
	.byte %00000000, $8a
	.byte %00011000, $86
	.byte %00000000, $82

	.byte %00011000, $82
	.byte %00000000, $86
	.byte %00000000, $8a
	.byte %10000001, $8a
	.byte %10000001, $8a
	.byte %00000000, $8a
	.byte %00000000, $86
	.byte %00011000, $82

PlayerGround1Shape
	.byte %01011010, $82
	.byte %10111101, $86
	.byte %01111110, $8a
	.byte %11100111, $8a
	.byte %11100111, $8a
	.byte %01111110, $8a
	.byte %10000001, $0d
	.byte %01111110, $0d

	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %00000000, $00
	.byte %10000001, $0d
	.byte %01111110, $0d

Player1Anim	; numero frames, offset frame n, offset frame n-1, .. , offset frame 1
	.byte 16, 16, 16, 16, 16, 16, 16, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0

PlayerDeath1Anim
	.byte 40
	.byte 96, 96, 96, 96
	.byte 96, 96, 96, 96
	.byte 80, 80, 80, 80
	.byte 80, 80, 80, 80
	.byte 64, 64, 64, 64
	.byte 64, 64, 64, 64
	.byte 48, 48, 48, 48
	.byte 48, 48, 48, 48
	.byte 32, 32, 32, 32
	.byte 32, 32, 32, 32

IntroPfColors
	.byte $00, $76, $78, $7a, $78, $76, $74, $72

MovePattern1	; 1 2
	.byte 3 , 0, 0, 1
MovePattern2	; 1 2
	.byte 3 , 0, 0, -1
MovePattern3	; 1 2
	.byte 2 , 0, 1
MovePattern4	; 1 2	; AND #3	First Levels	(and treats)
	.byte 2 , 0, -1

MovePattern5	; 2
	.byte 1 , 1
MovePattern6	; 2
	.byte 1 , -1
MovePattern7	; 2
	.byte 3 , 0, 1, 1
MovePattern8	; 2	; AND #7	Levels phase 2
	.byte 3 , 0, -1, -1
MovePattern9	; 3
	.byte 1 , 1
MovePattern10	; 3
	.byte 1 , -1
MovePattern11	; 3
	.byte 30 , 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0 ; ok (hard)
MovePattern12	; 3
	.byte 25 , 1,1,1,1,0,1,1,0,1,0,0,1,0,0,0,0,0,-1,-1,-1,0,0,0,0,0 ;
;	.byte 19, -1, -1, -1, 0,0, -1, -1, 0,0, -1, 0,0, -1, 0,0, -1, -1, 0,0 ; ok
;	.byte 28, -1,0, -1,0, -1,0, 0,0, -1,0, -1,0, 0,0, -1,0, 0,0, -1,0, 0,0, -1,0, -1,0, 0,0 ; ok
MovePattern13	; 3
	.byte 23 , 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0 ; ok
;	.byte 19 , 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0 ; ok
MovePattern14	; 3
	.byte 24, -1, -1, -1, -1, -1, 0, -1, -1, -1, 0, -1, -1, 0, -1, 0, -1, 0, -1, -1, 0, -1, -1, -1, 0	(very hard!)
;	.byte 22 , 0,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,-1,0,-1,0,0,0 ;ok
MovePattern15	; 3
	.byte 19 , 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0 ; ok
;	.byte 3 , 0, 1, 1
MovePattern16	; 3
	.byte 3 , 0, -1, -1

MovePattern17	; temp
;	.byte 25 , 1,1,1,1,0,1,1,0,1,0,0,1,0,0,0,0,0,-1,-1,-1,0,0,0,0,0 ;
;	.byte 14 -1, -1, -1, 0, -1, -1, 0, -1, 0, -1, 0, -1, -1, 0 ; ok
;	.byte 22 , 0,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,-1,0,-1,0,0,0 ;ok

;	.byte 22 , 0,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,-1,0,-1,0,0,0 ; ok
;	.byte 45,1,1,1,1,1,1,0,1,1,1,1,0,0,1,1,1,0,0,0,1,1,0,0,0,0,1,0,0,0,0,1,1,0,0,0,1,1,1,0,0,1,1,1,1,0 ; ok (but jumpy)
;	.byte 30 , 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0 ; ok (hard)
;	.byte 25 , 1,1,1,1,0,1,1,0,1,0,0,1,0,0,0,0,0,-1,-1,-1,0,0,0,0,0 ;
;	.byte 10 , 0, 1, 0, 1, 1, 1, 0, 1, 0, 0	; ko
;	.byte 19 , 1, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0 ; ok

;	.byte 24, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 0, 1, 0, 1, 0, 1, 1, 0, 1, 1, 1, 0	(very hard!)
;	.byte 28, -1,0, -1,0, -1,0, 0,0, -1,0, -1,0, 0,0, -1,0, 0,0, -1,0, 0,0, -1,0, -1,0, 0,0 ; ok
;	.byte 45,1,1,1,1,1,1,0,1,1,1,1,0,0,1,1,1,0,0,0,1,1,0,0,0,0,1,0,0,0,0,1,1,0,0,0,1,1,1,0,0,1,1,1,1,0 ; ok

; NUSIZ
; 0 (one copy)
; 1 (two copies close)
; 2 (two copies med)
; 3 (three copies close)
; 4 (2 copies wide)
;  5 (NO: double size)
; 6 (3 copies medium)
;  7 (NO: triple size)

NuSizList1
	.byte 4, 4, 6, 4, 6, 2, 4, 0

NuSizList2
	.byte 6, 6, 6, 4, 6, 6, 4, 4
;	.byte 5, 5, 5, 5, 5, 5, 5, 5

NuSizList3
	.byte 6, 6, 6, 6, 4, 6, 6, 6
;	.byte 7, 7, 7, 7, 7, 7, 7, 7

MissileStripePos
	.byte 1, 2, 3, 4, 5, 6, 4, 5

MissileXPosTable
	;.byte $2, $4, $6, $8, $a, $c, $d, $2
	;.byte $c, $c, $c, $c, $c, $c, $c, $c
	.byte $5, $6, $7, $7, $8, $9, $9, $b

SoundMovePlayer
	; Notes for AUDCx = 4 or 5
;	.byte 14,  30, 15, 30, 17, 30, 19, 30, 21, 30, 11, 30, 12, 30, 29

	; C=6
	.byte 4 *3+1, 6,  00, 01, 00,  15, 2, 20,  15, 2, 15,  15, 2, 5

SoundIntro
	; Crappy jingle (C=3 or C=1)
	.byte 8 *3+1, 1,  15, 20, 11,  15, 10, 17,  15, 10, 11,  15, 10, 17,  00, 5, 00,  15, 30, 11,  00, 10, 00,  15, 10, 17

	;.byte 4 *3,  00, 20, 17,  15, 5, 20,  00, 20, 17,  15, 4, 15


;	.byte 14,  30, 16, 30, 18, 30, 20, 30, 11, 30, 12, 30, 06, 30, 00

SoundGotFood
	; Siren (C = 4)
	.byte 4 *3+1, 4,  15, 20, 17,  15, 20, 11,  15, 20, 17,  15, 20, 11

SoundStartGame
	.byte 4 *3+1, 6,  00, 01, 00,  15, 2, 5,  15, 2, 15,  15, 2, 20

SoundFinishLevel
	.byte 6 *3+1, 4, 00, 1,00,  15, 5, 15,  00, 2, 00,  15, 5, 25 , 00, 2, 00,  15, 5, 30

SoundStartLevel
	.byte 8 *3+1, 4, 00, 2, 00,  15, 5, 20 , 00, 2, 00,  15, 10, 30, 00, 2, 00,  15, 5, 20, 00, 2, 00,  15, 10, 30

SoundPlayerExplode
	.byte 4 *3+1, 8, 00, 2, 00,  15, 20, 31,  15, 5, 29,  15, 10, 28

SoundFuelWarning
	.byte 10 *3+1, 4,  00, 2, 00,  15, 30, 30,  00, 100, 00,  15, 30, 30,  00, 100, 00,  15, 30, 30,  00, 100, 00,  15, 30, 30,  00, 100, 00,  15, 30, 30

SoundGetKey
	.byte 4 *3+1, 4, 00, 1,00,  15, 5, 15,  00, 2, 00,  15, 5, 30

Position6Sprites
	LDA     #$01
	STA     VDELP0
	STA     VDELP1
	LDA     #$03
	STA     NUSIZ0
	STA     NUSIZ1
	LDA     #$36
	STA     COLUP0
	STA     COLUP1

	LDA #0
	STA COLUBK
	STA COLUPF
	STA GRP0
	STA GRP1
	STA REFP0
	STA REFP1
	STY ENAM0
	STY ENAM1
	STY ENABL
;	STA RESP0
;	STA RESP1
	STA HMCLR

	STA     WSYNC

;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP	; 20 cycles
;	NOP
;	NOP

;	NOP
;	NOP
;	NOP
;	NOP
;	NOP

;	NOP
;	NOP
;	NOP	; 40 cycles total

	LDY #6		; 2
DelayLoop_introscreensprites1
	DEY		; 2 * 7
	BPL DelayLoop_introscreensprites1	; 3 * 6 + 2 =  cycles
	NOP
	NOP

	STA     RESP0	; Position sprites on the screen
	STA WSYNC

;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	NOP
;	bit $00
;	NOP	; 19 cycles
;	NOP
;	NOP

;	NOP
;	NOP
;	NOP
;	NOP
;	NOP

;	NOP
;	NOP
;	NOP	; 41 cycles

	LDY #7		; 2
DelayLoop_introscreensprites2
	DEY		; 2 * 7
	BPL DelayLoop_introscreensprites2	; 3 * 6 + 2 =  cycles

	STA     RESP1

;	LDA     #$50    ; .. and shift them
;	LDA     HMP1
;	LDA     #$40
;	STA     HMP0

	LDA     #$90    ; .. and shift them
	LDA     HMP1
	LDA     #$50
	STA     HMP0

	STA     WSYNC
	STA     HMOVE
	STA     WSYNC
	RTS

InitIntroScreen
	JSR Position6Sprites

; Load pointers to sprites data
	LDA #<IntroSpr0
	STA ptr0
	LDA #>IntroSpr0
	STA ptr0+1
	LDA #<IntroSpr1
	STA ptr1
	LDA #>IntroSpr1
	STA ptr1+1
	LDA #<IntroSpr2
	STA ptr2
	LDA #>IntroSpr2
	STA ptr2+1
	LDA #<IntroSpr3
	STA ptr3
	LDA #>IntroSpr3
	STA ptr3+1
	LDA #<IntroSpr4
	STA ptr4
	LDA #>IntroSpr4
	STA ptr4+1
	LDA #<IntroSpr5
	STA ptr5
	LDA #>IntroSpr5
	STA ptr5+1

	RTS

InitLevelScreen
	JSR Position6Sprites

; Load pointers to sprites data
	LDA #<LevelSpr0
	STA ptr0
	LDA #>LevelSpr0
	STA ptr0+1
	LDA #<LevelSpr1
	STA ptr1
	LDA #>LevelSpr1
	STA ptr1+1
	LDA #<LevelSpr2
	STA ptr2
	LDA #>LevelSpr2
	STA ptr2+1
	LDA #<LevelSpr3
	STA ptr3
	LDA #>LevelSpr3
	STA ptr3+1
	LDA #<Number0
	STA ptr4
	LDA #>Number0
	STA ptr4+1
	LDA #<Number1
	STA ptr5
	LDA #>Number1
	STA ptr5+1

	RTS

DrawIntroScreen
DrawIntroScreenLoop1
	LDA INTIM
	BNE DrawIntroScreenLoop1 ; Whew!
	STA WSYNC
	STA VBLANK  ;End the VBLANK period with a zero.
	LDA PF_Reflect
	STA CTRLPF  ; set playfield to reflect - G.S.
	LDA #0
	;
	STA COLUP0
	STA COLUP1; blacking out player colors
	LDA #$00 ; set playfield color to deep red
	STA COLUPF
	STA PFColorRAM
	;
	LDA #191 
	STA ScanLine
;	LDA #6
;	STA ScanPix
;	TAY
	LDY #6

;	LDX #30
	LDA #0
	STA PF0
	STA PF1
	STA PF2

	LDX #20
VPosition1
	STA WSYNC
	DEC ScanLine
	DEX
	BNE VPosition1

	LDA #$82
	STA COLUBK
	STA WSYNC
	LDA #$00
	STA COLUBK

	LDX #5
VPosition2
	STA WSYNC
	DEC ScanLine
	DEX
	BNE VPosition2
	;

	LDX #7

	LDA #$34 ; set playfield color to deep red
	STA COLUPF
ScanLoopIntroScreen
;	DEC ScanPix
	DEY
	BNE ScanGoIntroScreen
;	LDA #5
;	STA ScanPix
	LDY #5
	DEX			;next big pixel line
;	BNE ScanGoIntroScreen
;	JMP EndOfIntroScreen1
	BEQ EndOfIntroScreen1
ScanGoIntroScreen
	STA WSYNC
	LDA IntroPfColors,X
	STA COLUPF
	;
	; Time to begin cycle counting
	;
	LDA PFData0,X           ;[0]+4
	STA PF0                 ;[4]+3 = *7*   < 23	;PF0 visible
	
	LDA PFData1,X           ;[7]+4
	STA PF1                 ;[11]+3 = *14*  < 29	;PF1 visible
	
	LDA PFData2,X           ;[14]+4
	STA PF2                 ;[18]+3 = *21*  < 40	;PF2 visible

;	nop			;[21]+2
;	nop			;[23]+2
;	nop			;[25]+2
	;six cycles available  Might be able to do something here
	
	LDA PFData0b,X          ;[27]+4

	;PF0 no longer visible, safe to rewrite
	STA PF0                 ;[31]+3 = *34* 

	LDA PFData1b,X		;[34]+4

	;PF1 no longer visible, safe to rewrite
	STA PF1			;[38]+3 = *41*  

	LDA PFData2b,X		;[41]+4
	
	;PF2 rewrite must begin at exactly cycle 45!!, no more, no less
	STA PF2			;[45]+2 = *47*  ; > 46 PF2 no longer visible

	;76-47 = 29 cycles left per scanline available for
	; further calculations (i.e. sprites), not counting the rest of the
	; existing code below that branches off and changes the indexing to the letter graphics

	;nop adding even this one nop, however, breaks this kernel!
	;-Glenn Saunders
	
	DEC ScanLine
	BNE ScanLoopIntroScreen

EndOfIntroScreen1
	;
	LDA #$00
	STA COLUPF
	STA PF0
	STA PF1
	STA PF2

	LDX #6
VPosition3
	STA WSYNC
	DEC ScanLine
	DEX
	BNE VPosition3

	LDA #$82
	STA COLUBK
	STA WSYNC
	LDA #$00
	STA COLUBK

	LDY #10
VPosition4
	STA WSYNC
	DEY
	BPL VPosition4

;	JMP IntroSprites

;	ORG $FE00

IntroSprites

	LDA     #$36
	STA     COLUP0
	STA     COLUP1


;                LDY     TopDelay
;                INY     ;?????

;                LDA     #28	; 2
;		STA     LoopCount	; 3	(40 cycles)

;	LDA #28
	LDA #32
	JSR Display6Sprite

; --------------------------------
; --------------------------------

;	LDY #120
	LDY #76
EndIntroScreenLoop
	DEY
	STA WSYNC
	BNE EndIntroScreenLoop

;	LDA #2
;	STA WSYNC  ;Finish scanline 192.
;	STA VBLANK ; Make TIA output invisible,
	;
;	LDY #0
;	STY PF0
;	STY PF1
;	STY PF1
;	STY GRP0
;	STY GRP1
;	STY ENAM0
;	STY ENAM1
;	STY ENABL
;	STY NUSIZ0
;	STY NUSIZ1
	RTS

DrawLevelScreen
	LDA INTIM
	BNE DrawLevelScreen
	STA WSYNC
	STA VBLANK

	LDY #70
DrawLevelScreenDelay1
	STA WSYNC
	DEY
	BPL DrawLevelScreenDelay1

	LDA #7
	JSR Display6Sprite

	LDY #109
DrawLevelScreenDelay2
	STA WSYNC
	DEY
	BPL DrawLevelScreenDelay2

	RTS

	org $FE00

Display6Sprite
	STA     LoopCount	; 3	(40 cycles)
X1:
	STA     WSYNC

; 59 cycles
; 64 cycles
	LDY #11		; 2
DelayLoop1
	DEY		; 2 * 12
	BPL DelayLoop1	; 3 * 11 + 2 =  cycles
	BIT $00

; 9
X3:
	NOP
	NOP
	NOP
	LDY     LoopCount	; 3
	LDA     (ptr0),Y
	STA     GRP0
	LDA     (ptr1),Y
	STA     GRP1
	LDA     (ptr2),Y
	STA     GRP0
	LDA     (ptr5),Y
	STA     Temp
	LDA     (ptr4),Y
	TAX
	LDA     (ptr3),Y
	LDY     Temp
	STA     GRP1
	STX     GRP0
	STY     GRP1
	STA     GRP0
	DEC     LoopCount
	BPL     X3

	LDA     #0
	STA     GRP0
	STA     GRP1
	STA     GRP0
	STA     GRP1
	RTS

LevelSpr0
                                .byte   %11111011
                                .byte   %11011011
                                .byte   %11000011
                                .byte   %11000011
                                .byte   %11000011
                                .byte   %11000011
                                .byte   %11000011
                                .byte   %11000011
LevelSpr1
				.byte   %11100010
                                .byte   %01100111
                                .byte   %00000111
                                .byte   %10001101
                                .byte   %00001101
                                .byte   %00001101
                                .byte   %01101101
                                .byte   %11101101
LevelSpr2
                                .byte   %00111110
                                .byte   %00110110
                                .byte   %00110000
                                .byte   %10111000
                                .byte   %10110000
                                .byte   %10110000
                                .byte   %10110110
                                .byte   %10111110
LevelSpr3
                                .byte   %11111000
                                .byte   %11011000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000

NumbersShape
Number0
	.byte %01111100
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %01111100
Number1
	.byte %11111100
	.byte %00110000
	.byte %00110000
	.byte %00110000
	.byte %00110000
	.byte %11110000
	.byte %01110000
	.byte %00110000
Number2
	.byte %11111110
	.byte %11000000
	.byte %01100000
	.byte %00110000
	.byte %00011000
	.byte %00001100
	.byte %11000110
	.byte %01111100
Number3
	.byte %01111100
	.byte %11000110
	.byte %00000110
	.byte %00000110
	.byte %00011100
	.byte %00000110
	.byte %11000110
	.byte %01111100
Number4
	.byte %00000110
	.byte %11111110
	.byte %11000110
	.byte %01100110
	.byte %01100110
	.byte %00110000
	.byte %00110000
	.byte %00011000
Number5
	.byte %01111100
	.byte %11000110
	.byte %00000110
	.byte %00000110
	.byte %11111100
	.byte %11000000
	.byte %11000000
	.byte %11111110
Number6
	.byte %01111100
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %11111100
	.byte %11000000
	.byte %11000110
	.byte %01111100
Number7
	.byte %00110000
	.byte %00110000
	.byte %00011000
	.byte %00011000
	.byte %00001100
	.byte %00001100
	.byte %00000110
	.byte %11111110
Number8
	.byte %01111100
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %01111100
	.byte %11000110
	.byte %11000110
	.byte %01111100
Number9
	.byte %01111100
	.byte %11000110
	.byte %00000110
	.byte %01111110
	.byte %11000110
	.byte %11000110
	.byte %11000110
	.byte %01111100

;Exclamation
;	.byte %00011000
;	.byte %00000000
;	.byte %00011000
;	.byte %00011000
;	.byte %00011000
;	.byte %00011000
;	.byte %00011000
;	.byte %00011000

LivesSprite1
;	.byte %01011010,$82
;	.byte %00111100,$86
;	.byte %01111110,$8a
;	.byte %00111100,$86
;	.byte %01011010,$82

	.byte $82,%01011010
	.byte $86,%00111100
	.byte $8a,%01111110
	.byte $86,%00111100
	.byte $82,%01011010

LivesDisplayData
	.byte 0, 0,  0, 1 , 0, 3,  0, 3,  1, 3,  3, 3,   3, 3,  3, 3

StopSounds
	LDA #-1
	STA SoundChannel0Cnt	; Stop channel 0
	STA SoundChannel1Cnt	; Stop channel 0
	LDA #0
	STA AUDV0
	STA AUDV1
	RTS

MovePatternPointers
;	.byte >MovePattern17, <MovePattern17
	.byte >MovePattern1, <MovePattern1
	.byte >MovePattern2, <MovePattern2
	.byte >MovePattern3, <MovePattern3
	.byte >MovePattern4, <MovePattern4
	.byte >MovePattern5, <MovePattern5
	.byte >MovePattern6, <MovePattern6
	.byte >MovePattern7, <MovePattern7
	.byte >MovePattern8, <MovePattern8
	.byte >MovePattern9, <MovePattern9
	.byte >MovePattern10, <MovePattern10
	.byte >MovePattern11, <MovePattern11
	.byte >MovePattern12, <MovePattern12
	.byte >MovePattern13, <MovePattern13
	.byte >MovePattern14, <MovePattern14
	.byte >MovePattern15, <MovePattern15
	.byte >MovePattern16, <MovePattern16

	ORG $FF00

; --- Intro Screen Graphics ---
;               REFLECTED PLAYFIELD
;   PF0|   PF1  |  PF2   |   PF2b |   PF1b |PF0b|
;  4567|76543210|01234567|76543210|01234567|7654|

PFData0
	.byte $00, $70, $80, $80, $40, $20, $20, $C0

PFData1
	.byte $00, $45, $45, $45, $47, $65, $15, $E2

PFData2
	.byte $00, $CC, $22, $22, $62, $22, $02, $FC

PFData2b
	.byte $00, $25, $25, $25, $26, $25, $21, $7E
	
PFData1b
	.byte $00, $AC, $A2, $A2, $E6, $A2, $A2, $4C

PFData0b
	.byte $00, $20, $20, $20, $20, $20, $20, $70
	
; -----------------------------

; CGE 2k2 graphics

IntroSpr0
                                .byte   %00000100
                                .byte   %00000100
                                .byte   %00100110
                                .byte   %00000101
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001101
                                .byte   %00000110
                                .byte   %00000011
                                .byte   %00001101
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00011000
                                .byte   %00011100
                                .byte   %00011000
                                .byte   %00011011
                                .byte   %00011111
                                .byte   %00000000
                                .byte   %00000010
                                .byte   %00000100
                                .byte   %00000101
                                .byte   %00000100
                                .byte   %00000010
IntroSpr1
                                .byte   %01010011
                                .byte   %01010100
                                .byte   %01100110
                                .byte   %01010100
                                .byte   %01100011
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10110110
                                .byte   %10110110
                                .byte   %00111110
                                .byte   %00110110
                                .byte   %10110110
                                .byte   %10011100
                                .byte   %00000000
                                .byte   %01101101
                                .byte   %01101101
                                .byte   %01111101
                                .byte   %01101101
                                .byte   %01101101
                                .byte   %00111001
                                .byte   %00000000
                                .byte   %00100111
                                .byte   %10010100
                                .byte   %00010010
                                .byte   %10010001
                                .byte   %00100110
IntroSpr2
                                .byte   %01100110
                                .byte   %00010001
                                .byte   %00100010
                                .byte   %01000100
                                .byte   %00110011
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00100011
                                .byte   %01110011
                                .byte   %11011011
                                .byte   %11011011
                                .byte   %11011011
                                .byte   %11011001
                                .byte   %00000000
                                .byte   %11100110
                                .byte   %10110110
                                .byte   %11100111
                                .byte   %10110110
                                .byte   %10110110
                                .byte   %11100111
                                .byte   %00000000
                                .byte   %00100010
                                .byte   %01010101
                                .byte   %01010101
                                .byte   %01010101
                                .byte   %00100010
IntroSpr3
                                .byte   %00010001
                                .byte   %00010001
                                .byte   %00011001
                                .byte   %00010001
                                .byte   %00001101
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %01100111
                                .byte   %01101101
                                .byte   %11101111
                                .byte   %01101100
                                .byte   %01101101
                                .byte   %11000111
                                .byte   %00000000
                                .byte   %11011011
                                .byte   %11011011
                                .byte   %10011001
                                .byte   %11011000
                                .byte   %11011011
                                .byte   %10011011
                                .byte   %00000000
                                .byte   %01110000
                                .byte   %01000000
                                .byte   %00100000
                                .byte   %00010000
                                .byte   %01100000
IntroSpr4
                                .byte   %01010011
                                .byte   %01010100
                                .byte   %01100110
                                .byte   %01010100
                                .byte   %01100011
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00111110
                                .byte   %10110110
                                .byte   %10110000
                                .byte   %00110000
                                .byte   %10110000
                                .byte   %00110000
                                .byte   %00000000
                                .byte   %11101100
                                .byte   %01101101
                                .byte   %10001101
                                .byte   %11001101
                                .byte   %01101101
                                .byte   %11101100
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00010100
                                .byte   %00011000
                                .byte   %00010101
                                .byte   %00011001
IntroSpr5
                                .byte   %01000000
                                .byte   %00000000
                                .byte   %01001000
                                .byte   %01000000
                                .byte   %01000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %10110000
                                .byte   %10110000
                                .byte   %10110000
                                .byte   %10110000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %10000000
                                .byte   %10000000
                                .byte   %01000000
                                .byte   %01000000

;enemyDelays = $xx	; Array of MAX_STRIPES con i delay di EnemyMoves (uno per Stripe)
;enemyPos = $xx	; Array of MAX_STRIPES con i POS dei nemici, precalcolati (uno per Stripe)
;enemyOff = $xx	; Array of MAX_STRIPES con gli OFFset dei nemici, precalcolati (uno per Stripe)
;enemyX = $xx	; Array of MAX_STRIPES che ovviamente contiene le X dei nemici (una per Stripe)
; Totale: 32 bytes :( (diventeranno probabilemente 24 se riduco gli Stripes a 7)

;
; Graphics are placed so that the extra cycle in the PFData,X indexes
; is NEVER taken, by making sure it never has to index across a page
; boundary.  This way our cycle count holds true.
;

;	org $FF00 ; *********************** GRAPHICS DATA

;
; This is the tricky part of drawing a playfield: actually
; drawing it.  Well, the display routine and all that binary
; math was a bit tricky, too, but still, listen up.
;
; Playfield data isn't stored the way most bitmaps are, even
; one-dimensional bitmaps.  We will use the left side of the
; screen only, knowing that the right side is either repeated
; or reflected from it.
;
; In PF0 and PF2, the most significant bit (bit 7) is on the RIGHT
; side.  In PF1, the most significant bit is on the LEFT side.  This
; means that relative to PF0 and PF2, PF1 has a reversed bit order.
; It's just really weird.
;
;    PF0  |     PF1       |      PF2
;  4 5 6 7|7 6 5 4 3 2 1 0|0 1 2 3 4 5 6 7
;
; This is important to remember when doing calculations on bytes intended
; for the PF registers.  Defender gives a good example of this.
;
; It will become necessary to write a program that makes this easier,
; because it is easy to become confused when dealing with this system.
;

;ShiftTab ; 16
;	.byte $80, $90, $a0, $b0, $c0, $d0, $e0, $f0, $00, $10, $20, $30, $40, $50, $60, $70

	org $FFFC
	.word Start
	.word Start

; Letters: R
; Direction: <- (quindi flip anche sulle X)
; .byte $00, $f0, $00, $a0, $60, $e0, $a0, $e0
; 
; 00000000
; 11110000
; 00000000
; 10100000
; 01100000
; 11100000
; 10100000
; 11100000
; 
; Letters: AS
; Direction: -> (flip solo sulle Y)
; .byte $00, $ff, $00, $57, $51, $77, $54, $77
; 
; 00000000
; 11111111
; 00000000
; 01010111
; 01010001
; 01110111
; 01010100
; 01110111
; 
; Letters: TY
; Direction: <- (quindi flip anche sulle X)
; .byte $00, $ff, $00, $44, $44, $e4, $a4, $ae
; 
; 00000000
; 11111111
; 00000000
; 01000100
; 01000100
; 11100100
; 10100100
; 10101110


